Attribute VB_Name = "modVB6_m141"
' Lawson Labs, Inc.
' 3217 Phoenixville Pike
' Malvern, PA  19355
' 800 321-5355 or 610 725-8800
' World Wide Web - www.lawsonlabs.com
' Programmer - Tim Van Dusen
' Last modified: 8-9-99
' filename: VB6_M141
' NOTE: Uses 9x141Lib.dll

Option Explicit
'=======================================================================
'=======================================================================
'=======================================================================
'***********************************************************************
'**** T Y P E   A N D   V A R I A B L E   D E C L A R A T I O N S  *****
'***********************************************************************
'=======================================================================
'=======================================================================
'=======================================================================
'NOTE: type desc:
'       b=byte, ba=byte arrray, i=integer, l=long, dbl=double sz=string
Type M141
    iADC141 As Integer      ' ADC for Model 141
    dHertzRate As Double    ' scan rate (hz)
    iAverage As Integer     ' number of samples to average per point
    iIchDelay As Integer    ' interchannel delay
    bNumData As Byte        ' number of datapoints per scan
    lTotScans As Long       ' number of scans to perform (0 means unlimited)
    digInp As Byte          ' flag for digital input 1 = on  0 = off
    bBiPolar As Byte        ' 128 = bipolar, 0 = unipolar
    bControlCode As Byte    ' control code for next conversion in GetConv
    baCCode(0 To 32) As Byte ' array of control codes
    lNumCompleted As Long   ' number of scans completed if scan was aborted
    lCalTime As Long        ' time in milliseconds for calibration
    bCurChan As Byte        ' current channel
    dblVoltage As Double    ' voltage read by DLL
    ulScanStartTime As Long
End Type
Public M_141 As M141            'M141 structured data shared with DLL

Public h9x141Lib                'handle to DLL

Public bDebugLevel As Byte      'Amount of DLL debug file output desired

Public localAvg As Integer      'Averaging done in host

Public lRetVal As Long          'return value for misc functions
Public hLogFile As Long         'Log file handle
Public lScansCompleted As Long

Public fRetVal As Boolean       'return value for DLL functions
Public fStopScan As Boolean     'flag to stop scanning
Public fScanning As Boolean
Public fDoScanLog As Boolean
Public fExitPending As Boolean
Public fCalibationNeeded As Boolean

Public dblMaxHertzRate As Double

Public szMsg As String            'message string
Public szClock As String
Public szCfgFileSpec As String    'Config file name
Public szLogFileSpec As String    'Log file name


'=======================================================================
'=======================================================================
'=======================================================================
'***********************************************************************
'**** E X T E R N A L   F U N C T I O N   D E C L A R A T I O N S  *****
'***********************************************************************
'=======================================================================
'=======================================================================
'=======================================================================
'N O T E :  Commented lines are prototypes as used in DLL
'BOOLEAN DLL_Calibrate(BYTE bDebugLevel, T_M141* M141);
Declare Function DLL_Calibrate Lib "9x141Lib.dll" (ByVal bDebugLevel As Byte, _
            ByRef T_M141 As M141) As Boolean

'BOOLEAN DLL_SetupScan(void)
Declare Function DLL_SetupScan Lib "9x141Lib.dll" () As Boolean

'BOOLEAN DLL_GetConv(void)
Declare Function DLL_GetConv Lib "9x141Lib.dll" () As Boolean

'BOOLEAN DLL_ChanChange (void)
Declare Function DLL_ChanChange Lib "9x141Lib.dll" () As Boolean

'BOOLEAN DLL_GetDigin(void)
Declare Function DLL_GetDigin Lib "9x141Lib.dll" () As Boolean

'BOOLEAN DLL_WaitSettle(void)
Declare Function DLL_WaitSettle Lib "9x141Lib.dll" () As Boolean

'BOOLEAN DLL_ReadPortUCHAR(USHORT usPort, UCHAR* ucVal);
Declare Function DLL_ReadPortUCHAR Lib "9x141Lib.dll" _
        (ByVal usPort As Integer, ByRef ucVal As Byte) As Boolean

'BOOLEAN DLL_WritePortUCHAR(USHORT usPort, UCHAR ucVal);
Declare Function DLL_WritePortUCHAR Lib "9x141Lib.dll" _
        (ByVal usPort As Integer, ByRef ucVal As Byte) As Boolean

'Windows API external functions
Declare Function MessageBox Lib "user32" Alias "MessageBoxA" _
    (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, _
    ByVal wType As Long) As Long
Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" _
                (ByVal lpModuleName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetTickCount Lib "kernel32" () As Long
Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" _
                (ByVal lpExistingFileName As String, ByVal lpNewFileName _
                As String, ByVal bFailIfExists As Long) As Long
Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" _
            (ByVal lpFileName As String) As Long
'=======================================================================
'=======================================================================
'=======================================================================
'***********************************************************************
'**** R E A D   C O N F I G U R A T I O N   F I L E  *******************
'***********************************************************************
'=======================================================================
'=======================================================================
'=======================================================================
Public Sub ReadCfg()
TOP:
    Dim cf As Long
    Dim szStr As String
    szCfgFileSpec = "VB141.cfg"
    cf = FreeFile
    On Error GoTo NO_FILE
    Open szCfgFileSpec For Input As #cf
    
    Line Input #cf, szStr        'title and date
    Line Input #cf, szStr        'blank line
    Line Input #cf, szStr
    M_141.iADC141 = val(szStr)
    Line Input #cf, szStr
    M_141.dHertzRate = val(szStr)
    Line Input #cf, szStr
    M_141.iAverage = val(szStr)
    Line Input #cf, szStr
    M_141.iIchDelay = val(szStr)
    Line Input #cf, szStr
    M_141.bNumData = val(szStr)
    If M_141.bNumData = 0 Then M_141.bNumData = 1
    If M_141.bNumData > 31 Then M_141.bNumData = 31
    Line Input #cf, szStr
    M_141.lTotScans = val(szStr)
    Line Input #cf, szStr
    M_141.bBiPolar = val(szStr)
    Line Input #cf, szStr
    M_141.bControlCode = val(szStr)
    Dim arrayOffset As Byte
    For arrayOffset = 0 To 32
        Line Input #cf, szStr
        M_141.baCCode(arrayOffset) = val(szStr)
        If M_141.baCCode(arrayOffset) > 31 Then
            M_141.baCCode(arrayOffset) = 31
        End If
    Next arrayOffset
    
    Line Input #cf, szStr
    M_141.bCurChan = val(szStr)
    Line Input #cf, szStr
    bDebugLevel = val(szStr)
   
    Close #cf
    fRetVal = True

    GoTo EXIT_READ_CFG
    
NO_FILE:
    Dim bBtnType As Byte
    bBtnType = 36 'MB_YESNO | MB_ICONQUESTION
    lRetVal = MessageBox(0, vbCrLf & vbCrLf _
        & "Create new configuration file" & vbCrLf & vbCrLf _
        & "using default values?" _
        & vbCrLf & vbCrLf, "Configuration file not found", bBtnType)
    
    If lRetVal = 6 Then
        CreateDefaultCfg
        If fRetVal Then GoTo TOP
    End If
    
    MsgDisplay ("ERROR opening VB141.CFG" _
        & Chr(10) _
        & Chr(10) _
        & Chr(10) _
        & "Locate and place configuration file in" _
        & Chr(10) _
        & Chr(10) _
        & "same directory as application and try again." _
        & Chr(10) _
        & Chr(10))
    End
    
EXIT_READ_CFG:
    On Error GoTo 0
End Sub
Public Sub CreateDefaultCfg()
    On Error GoTo FILE_CREATE_ERROR

    Dim pCfgFile As Long
    szCfgFileSpec = "VB141cfg.tmp"
    pCfgFile = FreeFile
   
    On Error GoTo FILE_CREATE_ERROR
    Open szCfgFileSpec For Output As #pCfgFile
    
    Print #pCfgFile, "NOTICE:  See end of file for explanation of " _
            & "each entry below.  Date created: " & Date$ & "  " & Time$
    Print #pCfgFile, ""
    Print #pCfgFile, 560    'address of card
    Print #pCfgFile, 800    'rate
    Print #pCfgFile, 1      'average
    Print #pCfgFile, 568    'inter-channel delay
    Print #pCfgFile, 1      'number of data points per scan
    Print #pCfgFile, 0      'total scans (0 means unlimited)
    Print #pCfgFile, 128    'range (128=bipolar, 0=unipolar)
    Print #pCfgFile, 0      'external channel (polled mode)
    Dim arrayOffset As Byte 'array of control codes (external channels)
    For arrayOffset = 0 To 32
        Print #pCfgFile, arrayOffset
    Next arrayOffset
    Print #pCfgFile, 0      'current channel (polled mode)
    Print #pCfgFile, 3      'debug level.
    Print #pCfgFile, ""
    Print #pCfgFile, "_______________"
    Print #pCfgFile, "File entry info"
    Print #pCfgFile, "***************"
    Print #pCfgFile, "Line:   What it means:"

    Print #pCfgFile, "1" & vbTab & "=  M_141.iADC141"
    Print #pCfgFile, "2" & vbTab & "=  M_141.hertzRate"
    Print #pCfgFile, "3" & vbTab & "=  M_141.iAverage"
    Print #pCfgFile, "4" & vbTab & "=  M_141.iIchDelay"
    Print #pCfgFile, "5" & vbTab & "=  M_141.bNumData"
    Print #pCfgFile, "6" & vbTab & "=  M_141.lTotScans"
    Print #pCfgFile, "7" & vbTab & "=  M_141.bBiPolar"
    Print #pCfgFile, "8" & vbTab & "=  M_141.bControlCode"
    Print #pCfgFile, "9-41" & vbTab & "=  M_141.baCCode()"
    Print #pCfgFile, "42" & vbTab & "=  M_141.bCurChan"
    Print #pCfgFile, "43" & vbTab & "=  bDebugLevel"
    
    Close #pCfgFile
    
    fRetVal = CopyFile("VB141cfg.tmp", "VB141.cfg", False)
    DeleteFile ("VB141cfg.tmp")
    
    If fRetVal = False Then
        MsgBox vbCrLf & "Unable to save configuration file" _
            & vbCrLf & vbCrLf, vbOK
        End
    End If
    
    fRetVal = True
    
    GoTo EXIT1
    
FILE_CREATE_ERROR:
    MsgDisplay ( _
         Chr(10) _
        & Chr(10) _
        & "ERROR Creating VB141.CFG" _
        & Chr(10) _
        & Chr(10) _
        & Chr(10))
    On Error GoTo 0
    End
EXIT1:
End Sub
'=======================================================================
'=======================================================================
'=======================================================================
'***********************************************************************
'**** M E S S A G E   D I S P L A Y   H A N D L I N G  *****************
'***********************************************************************
'=======================================================================
'=======================================================================
'=======================================================================
Public Sub MsgDisplay(szMsg)
    'MsgBox szMsg, vbOK       'no title control so use one below
    lRetVal = MessageBox(0, szMsg, "Error ----", 0)
End Sub
Public Sub ScrollText()
    frmVB6_M141.txtMsgDisplay.SelStart = Len(frmVB6_M141.txtMsgDisplay) & vbCrLf
End Sub
'=======================================================================
'=======================================================================
'=======================================================================
'***********************************************************************
'**** R A T E    V A L I D A T I O N  **********************************
'***********************************************************************
'=======================================================================
'=======================================================================
'=======================================================================
Public Function RateValidate(rate As Double, calTime As Long, _
        numData As Byte, average As Integer, fUpdateClockOnly As Boolean)
    Dim updateTime As Double
    If calTime >= 5000 Then
        updateTime = 1# / 218#
        M_141.iIchDelay = 2270
        szClock = "218 KHz"
    ElseIf (calTime > 1500) And (calTime < 5000) Then
        updateTime = 1# / 874#
        M_141.iIchDelay = 568
        szClock = "895 KHz"
    ElseIf calTime <= 1500 Then
        updateTime = 1# / 3500#
        M_141.iIchDelay = 142
        szClock = "3580 KHz"
    End If
    If fUpdateClockOnly Then GoTo EXIT1
    
    If numData = 1 Then
        dblMaxHertzRate = 1# / (updateTime * M_141.iAverage * numData)
    Else
        dblMaxHertzRate = 1# / ((updateTime * M_141.iAverage + (M_141.iIchDelay / 1000#) _
                                        + 0.0003) * numData)
    End If
    
    If dblMaxHertzRate > 1000 Then dblMaxHertzRate = 1000
    If dblMaxHertzRate < 0 Then dblMaxHertzRate = 1
    
    If rate > dblMaxHertzRate Then
        MsgBox "Entered rate was too high." & vbCrLf & "Changing rate.", 0
    End If
EXIT1:
End Function
'=======================================================================
'=======================================================================
'=======================================================================
'***********************************************************************
'**** M A I N   P A N E L   C O N T R O L   (E N /D I S) A B L E  ******
'***********************************************************************
'=======================================================================
'=======================================================================
'=======================================================================
Public Sub MainPnlCtrlDisable()
        frmVB6_M141.cmdGetDigin.Enabled = False
        frmVB6_M141.btnGetConv.Enabled = False
        frmVB6_M141.txtVoltage.Enabled = False
        frmVB6_M141.btnScan.Enabled = False
        frmVB6_M141.LabelScansCompleted.Enabled = False
        frmVB6_M141.LabelVoltage.Enabled = False
        frmVB6_M141.ComboChan.Enabled = False
        frmVB6_M141.ComboSubChan.Enabled = False
        frmVB6_M141.LabelChan.Enabled = False
        frmVB6_M141.LabelSubChan.Enabled = False
        frmVB6_M141.LabelScanRate.Enabled = False
End Sub
Public Sub MainPnlCtrlEnable()
        frmVB6_M141.cmdGetDigin.Enabled = True
        frmVB6_M141.btnGetConv.Enabled = True
        frmVB6_M141.txtVoltage.Enabled = True
        frmVB6_M141.btnScan.Enabled = True
        frmVB6_M141.LabelScansCompleted.Enabled = True
        frmVB6_M141.btnChangeConfig.Enabled = True
        frmVB6_M141.LabelVoltage.Enabled = True
        frmVB6_M141.ComboChan.Enabled = True
        frmVB6_M141.ComboSubChan.Enabled = True
        frmVB6_M141.LabelChan.Enabled = True
        frmVB6_M141.LabelSubChan.Enabled = True
        frmVB6_M141.LabelScanRate.Enabled = True
End Sub
